function [] = main(dataset,experiment,run)
format compact;
if isdeployed
   dataset=str2num(dataset);
   experiment=str2num(experiment);
   run=str2num(run);
end

rand('seed',run);
tabdatasets={'covtype','alpha','ocr','real-sim','rcv1','webspam'};
path_datasets='/scratch2/clear/mairal/large_datasets/';
path_logs='/scratch2/clear/mairal/large_datasets/logs_siam_revision/';
tabepochs=[1 2 3 4 5 10 15 20 25 50];
addpath('SAG');
addpath('../../trunk/build/');

%% Load datasets
tabn=[581012 500000 2500000 72309 781265 250000];
n=tabn(dataset);
dataset=tabdatasets{dataset};
tablambda=[1/n 10/n 0.1/n];
if (strcmp(dataset,'covtype') | strcmp(dataset,'alpha') | strcmp(dataset,'ocr'))
   param.normalized=false; 
   load([path_datasets dataset '.full_norm.mat']);
else
   param.normalized=true;   % we have normalized every dataset
   load([path_datasets dataset '.full.mat']);
end
C=unique(y);
neg=find(y==C(1));
y(neg)=-1;
pos=find(y==C(2));
y(pos)=1;
n=size(X,2);
p=size(X,1);
ind=randperm(n);
X=X(:,ind);
y=y(ind);
clear ind;

%%% Set Up Experiment
loss='logistic';
regul='l2';
param.verbose=true;
param.numThreads=1;
param.regul=regul;
param.loss=loss;
Xt=X';
clear X;

for ii = 1:length(tablambda)
   param.lambda=tablambda(ii);
   lambda=param.lambda;
   name2=sprintf('%s/exp_%s_%s_%s_%d_%d_%d.mat',path_logs,loss,regul,dataset,ii,experiment,run);
   name=sprintf('%s/exp_dual_%s_%s_%s_%d_%d_%d.mat',path_logs,loss,regul,dataset,ii,experiment,run);
   if ~exist(name2) 
      continue;
   else
      load(name2);
   end

   dual=zeros(1,length(tabepochs));
   for kk = 1:length(tabepochs)
      epochs=tabepochs(kk);
      param.ista=false;
      w0=ws{kk};
      param.max_it=0;
      param.it0=1;
      param.verbose=true;
      param
      [w optim] = mexFistaFlat(y,Xt,w0,param);
      dual(kk)=optim(2);
   end
   save(name,'dual','-v7.3');
end
